unit bufferform;

interface

uses
  MMSystem, Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, dx_vgcore, dx_scene, dx_utils, ExtCtrls, AppEvnts;

type
  TForm4 = class(TForm)
    Timer1: TTimer;
    ApplicationEvents1: TApplicationEvents;
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure ApplicationEvents1Idle(Sender: TObject; var Done: Boolean);
  private
    { Private declarations }
    Bitmap: TBitmap;
    Buffer: TdxBitmap;
    Fps, Time, StartTime, NewTime, DeltaTime, RenderTime: single;
    RenderCount: integer;
  public
    { Public declarations }
  end;

var
  Form4: TForm4;

implementation

{$R *.dfm}

var
  C: TdxCamera;
  L: TdxLight;

procedure TForm4.FormCreate(Sender: TObject);
begin
  C := TdxCamera.Create(Self);
  C.Position.Vector := dxVector(0, -10, 0);

  L := TdxLight.Create(Self);
  L.Rotateangle.X := 45;
  L.Rotateangle.Y := -45;

  Buffer := TdxBitmap.Create(400, 300);
  Buffer.Canvas.SetCamera(C);
  Buffer.Canvas.SetLight(L);

  Bitmap := TBitmap.Create;
  Bitmap.HandleType := bmDIB;
  Bitmap.PixelFormat := pf32bit;
  Bitmap.Width := Buffer.Width;
  Bitmap.Height := Buffer.Height;
end;

procedure TForm4.FormPaint(Sender: TObject);
var
  i: integer;
begin
  if Buffer <> nil then
  begin
    Buffer.Canvas.Reset;
    Buffer.Canvas.Lighting := true;
    C.RotateAngle.Y := C.RotateAngle.Y + 0.1;
    Buffer.Canvas.SetCamera(C);
    Buffer.Canvas.SetLight(L);

    if Buffer.Canvas.BeginScene then
    begin
      Buffer.Canvas.Clear($ff202020);

      Buffer.Canvas.SetRenderState(rsGouraud);
      Buffer.Canvas.SetRenderState(rs3DScene);
      Buffer.Canvas.SetRenderState(rsZWriteOn);
      Buffer.Canvas.SetRenderState(rsTexLinear);

      Buffer.Canvas.Material.NativeDiffuse := $FF000000 or random($FFFFFF);

      Buffer.Canvas.SetMatrix(IdentityMatrix);
      Buffer.Canvas.FillCube(dxVector(0, 0, 0), dxVector(1, 1, 1), 1);
      Buffer.Canvas.DrawCube(dxVector(0, 0, 0), dxVector(1, 1, 1), 1);

      Buffer.Canvas.SetRenderState(rs2DScene);
      Buffer.Canvas.DrawText(10, 10, 'Just a text', 1);
      Buffer.Canvas.DrawText(10, 30, 'Fps : ' + FloatToStr(fps), 1);
      Buffer.Canvas.DrawText(10, 50, 'Rendering to VCL''s TBitmap object', 1);

      Buffer.Canvas.FlushBuffer;
      { flip, because TBitmap have diffirent alignment }
      for i := 0 to Buffer.Height - 1 do
        vgMoveLongword(@Buffer.Bits[i * Buffer.Width], Bitmap.ScanLine[i], Buffer.Width);
    end;

    Canvas.Draw(0, 0, Bitmap);
  end;
end;

procedure TForm4.ApplicationEvents1Idle(Sender: TObject;
  var Done: Boolean);
begin
  Done := false;

  if StartTime = 0 then
    StartTime := timeGetTime;
  NewTime := (timeGetTime - StartTime) / 1000;
  DeltaTime := NewTime - Time;
  Time := NewTime;
  RenderTime := RenderTime + DeltaTime;
  RenderCount := RenderCount + 1;
  if RenderTime > 1.0 then
  begin
    Fps := RenderCount / RenderTime;
  end;
  FormPaint(Self);
end;

end.
